import System

import Lexer
import Parser
import Emitter
import Optimizer
import Assembler
import Coder

main = do
  args <- getArgs
  do let 
      checkArgs x = any (== x) args

      optimizeJob = if checkArgs "-O0" then requiredOptimize else optimize
      codingJob = if checkArgs "--fxp" then codingFxp else coding

      compile = codingJob . assemble . optimizeJob . emit . parse . lexer

      job = if checkArgs "--lexonly" then unlines . map show . lexer
            else if checkArgs "--parseonly" then show . parse . lexer
                 else if checkArgs "--blockonly" then
                          showBlocks .
                          (if checkArgs "-O0" then id else optimizeBlocks) . 
                          splitBlocks . emit . parse . lexer
                      else compile
      in
        putStr . job =<< getContents
